unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, Vcl.Mask, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    ComboBoxLaufzeit: TComboBox;
    ComboBoxAnzahlProjekte: TComboBox;
    LabeledEditZinssatz1: TLabeledEdit;
    LabeledEditZinssatz2: TLabeledEdit;
    LabeledEditZinssatz3: TLabeledEdit;
    Button2: TButton;
    StringGridZahlungen: TStringGrid;
    procedure StringGridZahlungenSelectCell(Sender: TObject;
      ACol, ARow: Integer; var CanSelect: Boolean);
    procedure Button2Click(Sender: TObject);
    function StringGridLeer(genstrgrid: TStringGrid): TStringGrid;
    procedure ComboBoxAnzahlProjekteChange(Sender: TObject);
  private
    { Private-Deklarationen }
  var
    anzahlProjekte: Integer;
    laufzeit: Integer;
    zinsen1, zinsen2, zinsen3: double;
    procedure WriteHeadlines;
    procedure Datenuebernahme;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  math;

procedure TForm1.Button2Click(Sender: TObject);
var
  i: Integer;
  zk: string;
  k1, k2, k3: double;
  i0: double;
  value: double;
  einzahlungen: array of array of double;
  auszahlungen: array of array of double;
  ueberschuss: array of array of double;
  k: Integer;
  kmin, kmax: double;
  valueYAchse: double;
  z: Integer;
  kapitalwert: double;

begin
  Datenuebernahme;
  WriteHeadlines;
  SetLength(einzahlungen, anzahlProjekte, laufzeit + 1);
  SetLength(auszahlungen, anzahlProjekte, laufzeit + 1);
  SetLength(ueberschuss, anzahlProjekte, laufzeit + 1);


  // Daten aus Grid auslesen
  for k := 1 to anzahlProjekte do
  begin
    for i := 0 to laufzeit do
    begin
      // Einzahlungen
      zk := StringGridZahlungen.Cells[i + 1, 2 + (k - 1) * 4];
      if TryStrToFloat(zk, value) = False then
        value := 0;
      StringGridZahlungen.Cells[i + 1, 2 + (k - 1) * 4] := value.ToString();
      einzahlungen[k - 1, i] := value;
      // Auszahlungen
      zk := StringGridZahlungen.Cells[i + 1, 3 + (k - 1) * 4];
      if TryStrToFloat(zk, value) = False then
        value := 0;
      StringGridZahlungen.Cells[i + 1, 3 + (k - 1) * 4] := value.ToString();
      auszahlungen[k - 1, i] := value;
      // berschuss
      ueberschuss[k - 1, i] := einzahlungen[k - 1, i] - auszahlungen[k - 1, i];
      StringGridZahlungen.Cells[i + 1, 4 + (k - 1) * 4] := ueberschuss[k - 1, i]
        .ToString();
    end;
    // Kapitalwerte
    k1 := NetPresentValue(zinsen1 / 100, ueberschuss[k - 1],
      TPaymentTime.ptStartOfPeriod);
    StringGridZahlungen.Cells[laufzeit + 2, 4 + (k - 1) * 4] :=
      FloatToStrF(k1, ffNumber, 8, 2);
    k2 := NetPresentValue(zinsen2 / 100, ueberschuss[k - 1],
      TPaymentTime.ptStartOfPeriod);
    StringGridZahlungen.Cells[laufzeit + 3, 4 + (k - 1) * 4] :=
      FloatToStrF(k2, ffNumber, 8, 2);
    k3 := NetPresentValue(zinsen3 / 100, ueberschuss[k - 1],
      TPaymentTime.ptStartOfPeriod);
    StringGridZahlungen.Cells[laufzeit + 4, 4 + (k - 1) * 4] :=
      FloatToStrF(k3, ffNumber, 8, 2);
    // interner Zinsfu
    try
      i0 := InternalRateOfReturn(zinsen1, ueberschuss[k - 1]);
      StringGridZahlungen.Cells[laufzeit + 5, 4 + (k - 1) * 4] :=
        FloatToStrF(i0 * 100, ffNumber, 8, 5);
    except
      StringGridZahlungen.Cells[laufzeit + 5, 4 + (k - 1) * 4] := '';
    end;
    // Kapitalwertfunktion
    kmin := k1;
    kmax := k1;
    for z := 0 to 20 do
    begin
      kapitalwert := NetPresentValue(z / 100, ueberschuss[k - 1],
        TPaymentTime.ptStartOfPeriod);
      if kapitalwert < kmin then
        kmin := kapitalwert;
      if kapitalwert > kmax then
        kmax := kapitalwert;

    end;
  end;


end;

procedure TForm1.ComboBoxAnzahlProjekteChange(Sender: TObject);
begin
  StringGridZahlungen := StringGridLeer(StringGridZahlungen);
  Datenuebernahme;
  WriteHeadlines;
end;

constructor TForm1.Create(AOwner: TComponent);
begin
  inherited;
  anzahlProjekte := 1;
  laufzeit := 3;
  Datenuebernahme;
  WriteHeadlines;
  // Beispieldaten
  // Einzahlungen
  StringGridZahlungen.Cells[1, 2] := '0';
  StringGridZahlungen.Cells[2, 2] := '46500';
  StringGridZahlungen.Cells[3, 2] := '59200';
  StringGridZahlungen.Cells[4, 2] := '55700';
  // Auszahlungen
  StringGridZahlungen.Cells[1, 3] := '20000';
  StringGridZahlungen.Cells[2, 3] := '42500';
  StringGridZahlungen.Cells[3, 3] := '45200';
  StringGridZahlungen.Cells[4, 3] := '50700';

end;

procedure TForm1.Datenuebernahme;
begin
  laufzeit := strtoint(ComboBoxLaufzeit.Text);
  anzahlProjekte := strtoint(ComboBoxAnzahlProjekte.Text);
  StringGridZahlungen.ColCount := laufzeit + 6;
  StringGridZahlungen.RowCount := anzahlProjekte * 4 + 1;
  zinsen1 := strtoFloat(LabeledEditZinssatz1.Text);
  zinsen2 := strtoFloat(LabeledEditZinssatz2.Text);
  zinsen3 := strtoFloat(LabeledEditZinssatz3.Text);
end;

function TForm1.StringGridLeer(genstrgrid: TStringGrid): TStringGrid;
var
  i, j: Integer;

begin
  for i := genstrgrid.FixedCols to genstrgrid.ColCount - 1 do
  begin
    for j := genstrgrid.FixedRows to genstrgrid.RowCount - 1 do
    begin
      genstrgrid.Cells[i, j] := '';
    end;
  end;
  genstrgrid.RowCount := genstrgrid.FixedRows + 2;
  result := genstrgrid; // wieder zurckgeben
end;

procedure TForm1.StringGridZahlungenSelectCell(Sender: TObject;
  ACol, ARow: Integer; var CanSelect: Boolean);
var
  i: Integer;
begin
  for i := 1 to anzahlProjekte do
  begin
    if (ARow = (4 * i)) or (ARow = (4 * i - 3)) then
    begin
      StringGridZahlungen.options := StringGridZahlungen.options - [goediting];
      break
    end
    else
      StringGridZahlungen.options := StringGridZahlungen.options + [goediting]
  end;
end;

procedure TForm1.WriteHeadlines;
var
  i, k: Integer;
begin
  StringGridZahlungen.Cells[0, 0] := 'Jahr';
  for i := 0 to anzahlProjekte - 1 do
  begin
    StringGridZahlungen.Cells[0, i * 4 + 1] := 'Projekt: ' + (i + 1).ToString;
    StringGridZahlungen.Cells[0, i * 4 + 2] := 'Einzahlung';
    StringGridZahlungen.Cells[0, i * 4 + 3] := 'Auszahlungen';
    StringGridZahlungen.Cells[0, i * 4 + 4] := 'berschuss';
    for k := 0 to laufzeit do
      StringGridZahlungen.Cells[k + 1, 0] := k.ToString;

    StringGridZahlungen.Cells[laufzeit + 2, 0] := 'K(i1)';
    StringGridZahlungen.Cells[laufzeit + 3, 0] := 'K(i2)';
    StringGridZahlungen.Cells[laufzeit + 4, 0] := 'K(i3)';
    StringGridZahlungen.Cells[laufzeit + 5, 0] := 'i*'
  end;
end;

end.

